SystemOrganization addCategory: #'Generic-Spreadsheet'!

Object subclass: #GenericSpreadsheet
	instanceVariableNames: 'title id worksheetNum anArrayOfWorksheets'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Generic-Spreadsheet'!

!GenericSpreadsheet commentStamp: 'SauravBhattacharya 5/21/2012 20:43' prior: 0!
Class intention
	I am creating a GenericSpreadsheet class for Spreadsheet support in Pharo Smalltalk.

Class collaborations
	I usually do not work in isolation but with the help of Yuriy Mironenko and Carla Florencia.!

!GenericSpreadsheet methodsFor: 'as yet unclassified' stamp: 'SauravBhattacharya 5/26/2012 13:56'!
id
	"comment stating purpose of message"

	| temporary variable names |
	^ id.! !

!GenericSpreadsheet methodsFor: 'accessing' stamp: 'SauravBhattacharya 5/21/2012 20:38'!
id: aSmallInteger 
	id:= aSmallInteger .! !

!GenericSpreadsheet methodsFor: 'initialize-release' stamp: 'SauravBhattacharya 6/15/2012 22:04'!
initialize 
	"comment stating purpose of message"
	
	| temporary variable names |
	super initialize .
	worksheetNum :=1.
	anArrayOfWorksheets := Array new: 100.
	anArrayOfWorksheets at: 1 put: GenericWorksheet new.! !

!GenericSpreadsheet methodsFor: 'as yet unclassified' stamp: 'SauravBhattacharya 6/16/2012 05:25'!
newWorksheet: aTitle
	"comment stating purpose of message"

	| temporary variable names ws |
	
	worksheetNum := worksheetNum +1.
	anArrayOfWorksheets at: worksheetNum put: GenericWorksheet new .
	
	ws:=anArrayOfWorksheets at: worksheetNum  .
	ws id: worksheetNum.
	ws title: aTitle.
	ws spreadsheetID: self id.! !

!GenericSpreadsheet methodsFor: 'accessing' stamp: 'SauravBhattacharya 5/26/2012 14:33'!
title
	"comment stating purpose of message"

	| temporary variable names |
	^title! !

!GenericSpreadsheet methodsFor: 'accessing' stamp: 'SauravBhattacharya 5/21/2012 20:33'!
title: aByteString 
	title:= aByteString .! !

!GenericSpreadsheet methodsFor: 'as yet unclassified' stamp: 'SauravBhattacharya 6/15/2012 14:32'!
worksheetAt:index
	"comment stating purpose of message"

	| temporary variable names |
	^ anArrayOfWorksheets at: index! !

!GenericSpreadsheet methodsFor: 'as yet unclassified' stamp: 'SauravBhattacharya 6/15/2012 14:28'!
worksheetNum
	"comment stating purpose of message"

	| temporary variable names |
	^worksheetNum ! !

Object subclass: #GenericWorksheet
	instanceVariableNames: 'title maxNumOfRows maxNumOfColumns id spreadsheetID aMatrixOfCells aRowOfCells'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Generic-Spreadsheet'!

!GenericWorksheet methodsFor: 'as yet unclassified' stamp: 'SauravBhattacharya 6/15/2012 15:19'!
cellAt:row at:column
	"comment stating purpose of message"

	| temporary variable names |
	^(aMatrixOfCells at:row ) at:column.
	! !

!GenericWorksheet methodsFor: 'as yet unclassified' stamp: 'SauravBhattacharya 6/15/2012 14:26'!
id
	"comment stating purpose of message"

	| temporary variable names |
	^id! !

!GenericWorksheet methodsFor: 'accessing' stamp: 'SauravBhattacharya 5/21/2012 20:27'!
id: aSmallInteger 
	id:=aSmallInteger .! !

!GenericWorksheet methodsFor: 'as yet unclassified' stamp: 'SauravBhattacharya 6/16/2012 11:28'!
initialize 
	"Worksheet of size 1000*50 is generated"

	| temporary variable names |
	super initialize .
	self title: 'Worksheet'.
	"aMatrixOfCells :=  Matrix new: 20 tabulate: [ :i :j | self newCellAt: i at: j ]"
	aMatrixOfCells :=  Array new: 1000.
	1 to: 1000 do: [:row | 
		aRowOfCells :=  Array new: 50.
		1 to:  50 do: [:col | 
			aRowOfCells at:col put: (self newCellAt: row at:col).
		].
		aMatrixOfCells at:row put:aRowOfCells	.
	].
	self maxNumOfColumns: 5.
	self  maxNumOfRows: 20
	"self maxNumOfRows: 20.
	self maxNumOfColumns: 20."
	! !

!GenericWorksheet methodsFor: 'as yet unclassified' stamp: 'SauravBhattacharya 6/16/2012 05:34'!
maxNumOfColumns
	"comment stating purpose of message"

	| temporary variable names |
	^maxNumOfColumns.! !

!GenericWorksheet methodsFor: 'accessing' stamp: 'SauravBhattacharya 5/21/2012 20:24'!
maxNumOfColumns: aSmallInteger 
	maxNumOfColumns:= aSmallInteger .! !

!GenericWorksheet methodsFor: 'as yet unclassified' stamp: 'SauravBhattacharya 6/16/2012 05:34'!
maxNumOfRows
	"comment stating purpose of message"

	| temporary variable names |
	^maxNumOfRows.! !

!GenericWorksheet methodsFor: 'accessing' stamp: 'SauravBhattacharya 5/21/2012 20:24'!
maxNumOfRows: aSmallInteger 
	maxNumOfRows:=aSmallInteger .! !

!GenericWorksheet methodsFor: 'as yet unclassified' stamp: 'SauravBhattacharya 6/15/2012 15:09'!
newCellAt: i at: j 
	"comment stating purpose of message"

	| temporary variable names c |
	c:= XLSCell new.
	c rowID: i.
	c columnID: j.
	c worksheetID: self id.
	^c! !

!GenericWorksheet methodsFor: 'accessing' stamp: 'SauravBhattacharya 5/21/2012 20:38'!
spreadsheetID: aSmallInteger 
	spreadsheetID:= aSmallInteger .! !

!GenericWorksheet methodsFor: 'as yet unclassified' stamp: 'SauravBhattacharya 6/15/2012 22:31'!
title
	"comment stating purpose of message"

	| temporary variable names |
	^title.! !

!GenericWorksheet methodsFor: 'accessing' stamp: 'SauravBhattacharya 5/21/2012 20:23'!
title: aByteString 
	title:= aByteString .! !

Object subclass: #XLSCell
	instanceVariableNames: 'value type isNumeric worksheetID rowID columnID statements isFormula isData fontcolor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Generic-Spreadsheet'!

!XLSCell methodsFor: 'accessing' stamp: 'SauravBhattacharya 5/21/2012 20:30'!
columnID: aByteString 
	columnID := aByteString .! !

!XLSCell methodsFor: 'as yet unclassified' stamp: 'SauravBhattacharya 6/25/2012 12:52'!
fontcolor
	"comment stating purpose of message"

	| temporary variable names |
	^ fontcolor! !

!XLSCell methodsFor: 'as yet unclassified' stamp: 'SauravBhattacharya 6/25/2012 12:52'!
fontcolor: aColor
	"comment stating purpose of message"

	| temporary variable names |
	fontcolor :=  aColor .! !

!XLSCell methodsFor: 'as yet unclassified' stamp: 'SauravBhattacharya 6/25/2012 13:06'!
initialize 
	"comment stating purpose of message"

	| temporary variable names |
	super initialize.
	self value:'cell'.
	self fontcolor: 'null'.! !

!XLSCell methodsFor: 'accessing' stamp: 'SauravBhattacharya 5/21/2012 22:59'!
isData: aBoolean 
	"comment stating purpose of message"

	| temporary variable names |
	isData:= aBoolean .! !

!XLSCell methodsFor: 'accessing' stamp: 'SauravBhattacharya 5/21/2012 22:58'!
isFormula: aBoolean
	"comment stating purpose of message"

	| temporary variable names |
	isFormula := aBoolean ! !

!XLSCell methodsFor: 'accessing' stamp: 'SauravBhattacharya 5/21/2012 20:15'!
isNumeric: aBoolean 
	isNumeric:= aBoolean .! !

!XLSCell methodsFor: 'accessing' stamp: 'SauravBhattacharya 5/21/2012 20:30'!
rowID: aSmallInteger 
	rowID:=aSmallInteger .! !

!XLSCell methodsFor: 'accessing' stamp: 'SauravBhattacharya 5/21/2012 19:57'!
type: aByteString 
	type:= aByteString .! !

!XLSCell methodsFor: 'as yet unclassified' stamp: 'SauravBhattacharya 6/16/2012 05:26'!
value
	"comment stating purpose of message"

	| temporary variable names |
	^value! !

!XLSCell methodsFor: 'accessing' stamp: 'SauravBhattacharya 5/21/2012 19:54'!
value: aValue
	value:= aValue.! !

!XLSCell methodsFor: 'accessing' stamp: 'SauravBhattacharya 6/25/2012 13:04'!
value: aByteString fontcolor: aByteString2 
	self shouldBeImplemented.! !

!XLSCell methodsFor: 'accessing' stamp: 'SauravBhattacharya 5/21/2012 20:29'!
worksheetID: aSmallInteger 
	worksheetID:=aSmallInteger .! !

Object subclass: #XLSColumn
	instanceVariableNames: 'id width worksheetID'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Generic-Spreadsheet'!

!XLSColumn methodsFor: 'accessing' stamp: 'SauravBhattacharya 5/21/2012 20:05'!
id: aByteString 
	id:=aByteString .! !

!XLSColumn methodsFor: 'accessing' stamp: 'SauravBhattacharya 5/21/2012 20:08'!
width:  aSmallInteger 
	width := aSmallInteger .! !

!XLSColumn methodsFor: 'accessing' stamp: 'SauravBhattacharya 5/21/2012 20:40'!
worksheetID: aSmallInteger 
	worksheetID:= aSmallInteger .! !

Object subclass: #XLSRow
	instanceVariableNames: 'id height worksheetID'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Generic-Spreadsheet'!

!XLSRow methodsFor: 'accessing' stamp: 'SauravBhattacharya 5/21/2012 20:09'!
height: aSmallInteger 
	height := aSmallInteger .! !

!XLSRow methodsFor: 'accessing' stamp: 'SauravBhattacharya 5/21/2012 20:07'!
id: aSmallInteger 
	id := aSmallInteger .! !

!XLSRow methodsFor: 'accessing' stamp: 'SauravBhattacharya 5/21/2012 20:40'!
worksheetID: aSmallInteger 
	worksheetID:= aSmallInteger .! !
